unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, db, dbf, FileUtil, Forms, Controls, Graphics, Dialogs,
  DBGrids, ExtCtrls, StdCtrls, dbf_idxfile;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    ComboBox1: TComboBox;
    DataSource1: TDataSource;
    Dbf1: TDbf;
    DBGrid1: TDBGrid;
    EdSuche: TEdit;
    Label1: TLabel;
    Panel1: TPanel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Dbf1FilterRecord(DataSet: TDataSet; var Accept: Boolean);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
    FNameField: TField;
    procedure NameFieldGetText(Sender: TField; var aText: string; DisplayText: Boolean);
    procedure NameFieldSetText(Sender: TField; const aText: string);
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  Variants, LCLIntf, LConvEncoding, LazUtf8;

function HexStr(s: String): String;
var
  i: Integer;
begin
  Result := '';
  for i:=1 to Length(s) do
    Result := Format('%s %.2x', [Result, ord(s[i])]);
  if Result <> '' then
    Delete(Result, 1, 1);
end;

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  bm: TBookmark;
begin
  case Combobox1.ItemIndex of
    0: begin  // Locate
         bm := Dbf1.Bookmark;
         Dbf1.Filter := '';
         Dbf1.OnFilterRecord := nil;
         Dbf1.Filtered := false;
         if not dbf1.Locate('Name', UTF8ToCP1252(EdSuche.Text), [loCaseInsensitive, loPartialKey]) then
           Dbf1.BookMark := bm;
         Dbf1.FreeBookmark(bm);
       end;
    1: begin   // Filter
         Dbf1.Filter := 'Name="' + UTF8ToCP850(EdSuche.Text) + '*"';
         Dbf1.Filtered := true;
       end;
    2: begin   // OnFilterRecord
         Dbf1.OnFilterRecord := @Dbf1FilterRecord;
         Dbf1.Filtered := false;
         Dbf1.Filtered := true;
       end;
    3: begin
         Dbf1.OnFilterRecord := nil;
         Dbf1.Filter := '';
         Dbf1.Filtered := false;
       end;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  s: String;
  F: TField;
begin
  F := dbf1.FieldByName('Name');
  dbf1.First;
  while not dbf1.EOF do begin
    s := F.AsString;
    WriteLn('dbf.FieldByname(''Name'').AsString = ', s, ' = ', HexStr(s));
    dbf1.Next;
  end;
end;

procedure TForm1.Dbf1FilterRecord(DataSet: TDataSet; var Accept: Boolean);
var
  s: rawbytestring;
begin
  s := Dataset.FieldByName('Name').AsString;
  WriteLn('s = ', s, ' = ', HexStr(s));
  s := CP850ToUTF8(Dataset.FieldByName('Name').AsString);
  Accept := pos(EdSuche.Text, s) = 1;
end;

procedure TForm1.FormCreate(Sender: TObject);
const
  TableName : String = 'Test';
begin

  dbf1.FilePath := '';
  dbf1.TableName := TABLENAME + '.dbf';
  dbf1.TableLevel := 7;

  if not FileExists(dbf1.FilePathFull + dbf1.TableName) then
  begin
    with dbf1.FieldDefs do begin
      Add('Name', ftString, 20, true);
    end;
    dbf1.CreateTable;
    dbf1.Close;
  (*
    dbf1.Exclusive := True;
    dbf1.Open;
    dbf1.AddIndex('name_idx', 'Name', [ixPrimary, ixCaseInsensitive]);
    dbf1.Close;
    *)
    dbf1.Open;

    dbf1.Append;
    dbf1.FieldByName('Name').AsString := UTF8ToCP850('Meier');
    dbf1.Post;

    dbf1.Append;
    dbf1.FieldByName('Name').AsString := UTF8ToCP850('Müller');
    dbf1.Post;

    dbf1.Append;
    dbf1.FieldByName('Name').AsString := UTF8ToCP850('Wächter');
    dbf1.Post;

    dbf1.Append;
    dbf1.FieldByName('Name').AsString := UTF8ToCP850('Rotkäppchen');
    dbf1.Post;

    dbf1.Append;
    dbf1.FieldByName('Name').AsString := UTF8ToCP850('Maler');
    dbf1.Post;
  end;

//  dbf1.IndexName := 'name_idx';
  dbf1.Open;

  FNameField := dbf1.FieldByName('Name');
  FNameField.OnGetText := @NameFieldGetText;
  FNameField.OnSetText := @NameFieldSetText;

  Label1.Caption := 'CP' + IntToStr(dbf1.DbfFile.FileCodePage);
end;

procedure TForm1.NameFieldGetText(Sender: TField; var aText: string;
  DisplayText: Boolean);
begin
  AText := CP850ToUTF8(Sender.AsString);
end;

procedure TForm1.NameFieldSetText(Sender: TField; const aText: string);
begin
  Sender.AsString := UTF8ToCP850(AText);
end;

end.

